#(ie. use with rpm --rebuild):
#
#	--with debug	Compile with debugging code
# 
#  enable build with debugging code: will _not_ strip away any debugging code,
#  will _add_ -g3 to CFLAGS, will _add_ --enable-maintainer-mode to 
#  configure.

%define build_debug 0
%define build_test 0
%define build_oqgraph 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_debug: %{expand: %%define build_debug 1}}
%{?_with_test: %{expand: %%define build_test 1}}
%{?_without_test: %global build_test 0}
%{?_with_oqgraph: %{expand: %%define build_oqgraph 1}}
%{?_without_oqgraph: %global build_oqgraph 0}

%bcond_with     java

%if %{build_debug}
# disable build root strip policy
%define __spec_install_post %{_libdir}/rpm/brp-compress || :

# This gives extra debuggin and huge binaries
%{expand:%%define optflags %{optflags} %([ ! $DEBUG ] && echo '-g3')}
%endif

%if %{build_debug}
%define build_debug 1
%endif

%if %{build_test}
%define build_test 1
%endif

%if %{build_oqgraph}
%define build_oqgraph 1
%endif

%define major 18
%define libmysqlembedded_major 0
%define libmysqlembedded_minor 0.1
%define libname %mklibname mariadb %{major}
%define libmariadbservices %mklibname mariadbservices
%define libmariadbembedded %mklibname mariadb-embedded %{major}
%define develname %mklibname -d mariadb
%define old_staticdevelname %mklibname -d -s mariadb
%define libmariadbembedded_devel %mklibname -d mariadb-embedded

%define mysql_libname %mklibname mysql %{major}
%define mysql_develname %mklibname -d mysql
%define libmysqlservices %mklibname mysqlservices
%define libmysqlembedded %mklibname mysqld %{libmysqlembedded_major}
%define libmysqlembedded_devel %mklibname -d mariadb-embedded

%define mirror	http://ftp.osuosl.org/pub/mariadb

%define muser	mysql

# rule out some useless autodeps in the test suite
%global __requires_exclude perl\\(th|perl\\(lib|perl\\(mtr|perl\\(My
%global __provides_exclude perl\\(th|perl\\(lib|perl\\(mtr|perl\\(My

Summary:	A very fast and reliable SQL database engine
Name: 		mariadb
Version:	10.1.20
Release:	%mkrel 1
Group:		Databases
License:	GPLv2 with exceptions
URL:		http://mariadb.org/
Source0:    %{mirror}/%{name}-%{version}/source/%{name}-%{version}.tar.xz
Source1:	mysqld
Source3:	my.cnf
Source12:	mysqld-prepare-db-dir
Source13:	mysqld-wait-ready

# config files to load plugins
Source50:	auth_pam.cnf
Source51:	auth_socket.cnf
Source52:	ha_archive.cnf
Source53:	ha_blackhole.cnf
Source54:	ha_cassandra.cnf
Source55:	ha_connect.cnf
Source56:	ha_federatedx.cnf
Source57:	handlersocket.cnf
Source58:	ha_oqgraph.cnf
Source59:	ha_sequence.cnf
Source60:	ha_sphinx.cnf
Source61:	ha_spider.cnf
Source62:	locales.cnf
Source63:	metadata_lock_info.cnf
Source64:	query_cache_info.cnf
Source65:	query_response_time.cnf
Source66:	semisync_master.cnf
Source67:	semisync_slave.cnf
Source68:	sql_errlog.cnf
Source69:	feedback.cnf
Source70:	ha_innodb.cnf
Source71:	server_audit.cnf
Source72:	ha_mroonga.cnf

# the following patches are rediffed from the mysql-5.5 src.rpm to mariadb-5.5 
# fedora patches
Patch1: 	mariadb-10.1.12-errno.patch
Patch3: 	mariadb-5.5-install-test.patch

# mandriva patches
Patch101:	mariadb-5.5-logrotate.patch
Patch106:	mariadb-5.5-hotcopy.patch
Patch107:	mariadb-5.5-mysql_install_db-quiet.patch

Requires(post):  rpm-helper
Requires(preun): rpm-helper
Requires(post): %{name}-common = %{version}-%{release}
Requires(preun): %{name}-common = %{version}-%{release}
Requires(post): %{name}-client = %{version}-%{release}
Requires(preun): %{name}-client = %{version}-%{release}
Requires(postun): %{name}-common = %{version}-%{release}
Requires(postun): %{name}-client = %{version}-%{release}
Requires: %{name}-common = %{version}-%{release}
Requires: %{name}-core = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release}
Requires: %{name}-obsolete = %{version}-%{release}
Obsoletes:	mysql
Provides:	mysql = %{version}-%{release}
Obsoletes:  MySQL
Provides:   MySQL = %{version}-%{release}

Obsoletes: mysql-maxn
Obsoletes: mysql-doc
Obsoletes: mysql-ndb-extra
Obsoletes: mysql-ndb-management
Obsoletes: mysql-ndb-storage
Obsoletes: mysql-ndb-tools

BuildRequires:	bison
BuildRequires:	cmake
BuildRequires:	doxygen
BuildRequires:	glibc-devel
BuildRequires:	libaio-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtermcap-devel
BuildRequires:	multiarch-utils
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:	wrap-devel
BuildRequires:	python
BuildRequires:	tetex
BuildRequires:	texinfo
BuildRequires:	xfs-devel
BuildRequires:	zlib-devel
BuildRequires:	libaio-devel
BuildRequires:	pam-devel
BuildConflicts:	edit-devel
BuildRequires:	python-devel
BuildRequires:	icu-devel
BuildRequires:	bzip2-devel
# use system jemalloc libs instead of bundled ones
BuildRequires:	jemalloc-devel
%if %{build_oqgraph}
# required by oqgraph v3
BuildRequires:	boost-devel
BuildRequires:	judy-devel
%endif
%if %with java
# required by cassandra
BuildRequires:	thrift-devel
%endif
BuildRequires:	pcre-devel
BuildRequires:	libpcre0-devel
BuildRequires:	lz4-devel
BuildRequires:  libkrb53-devel
BuildRequires:  libcrack-devel
BuildRequires:	lzma-devel
BuildRequires:	liblzo-devel
BuildRequires:  glibc-devel

%description
The MariaDB software delivers a very fast, multi-threaded, multi-user, and
robust SQL (Structured Query Language) database server. MariaDB Server is
intended for mission-critical, heavy-load production systems as well as for
embedding into mass-deployed software.

The mariadb server is compiled with the following storage engines:

 - Aria Storage Engine
 - Archive Storage Engine
 - Blackhole Storage Engine
 - CSV Storage Engine
 - FederatedX Storage Engine (Federated replacement)
 - Heap Storage Engine
 - MyISAM Storage Engine
 - MyISAMMRG Storage Engine
 - Partition Storage Engine
 - Perfschema Storage Engine
 - Percona XtraDB Storage Engine (InnoDB replacement)

A multitude of storage engines and handlers are being provided in separate sub
packages such as:

%if %with java
mariadb-cassandra	- Cassandra Storage Engine
%endif
mariadb-feedback	- Feedback Storage Engine
mariadb-oqgraph		- Open Query GRAPH computation engine
mariadb-connect		- CONNECT handler
mariadb-sphinx		- Sphinx Storage Engine
mariadb-sequence	- Sequence Storage Engine
mariadb-spider		- Spider Storage Engine

The following extra storage engines are provided by the mariadb-extra package

 - handlersocket
 - query_cache_info

The following storage engines are provided in the mariadb-obsolete package

 - Federated Storage Engine

%package -n	mysql-MariaDB
Summary:	A MySQL drop-in replacement
Group:		System/Servers
Requires:	%{name}

%description -n	mysql-MariaDB
MariaDB is a complete MySQL drop-in replacement with additional fixes and
storage engines.

This package is used as a transitional virtual package, which requires
MariaDB so that people who used to use mysql can find it nicely.

%if %with java
%package	cassandra
Summary:	Cassandra Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	cassandra
The Cassandra Storage Engine allows access to data in a Cassandra cluster from
MariaDB.
%endif

%package	feedback
Summary:	Feedback storage engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	feedback
MariaDB feedback storage engine submits feedback about your mariadb server.
Results can be seen on http://mariadb.org/feedback_plugin/ .

%if %{build_oqgraph}
%package	oqgraph
Summary:	Open Query GRAPH computation engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	oqgraph
The Open Query GRAPH computation engine allows you to handle hierarchies
(tree structures) and complex graphs (nodes having many connections in
several directions).
%endif

%package	connect
Summary:	CONNECT handler
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	connect
The CONNECT handler enables MariaDB to access external local or remote data.
This is done by defining tables based on different data types, in particular
files of various format, data extracted from other products (such as Excel),
or data retrieved from the environment (for example DIR, WMI, and MAC tables).

This handler supports MariaDB virtual columns and also permits to define 
“special” columns such as ROWID and FILEID.

%package	sphinx
Summary:	Sphinx Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	sphinx
SphinxSE is a storage engine that talks to searchd (Sphinx daemon) to enable
full text searching.

%package	mroonga
Summary:	Mroonga Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	mroonga
Mroonga is a storage engine for MySQL. It provides fast fulltext search feature
to all MySQL users. Mroonga was called Groonga storage engine.

%package	sequence
Summary:	Sequence Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	sequence
A Sequence engine allows the creation of ascending or descending sequences of
numbers with a given starting value, ending value and increment.

It creates completely virtual, ephemeral tables automatically when you need
them. There is no way to create a Sequence table explicitly. Nor are they ever
written to disk or create .frm files. They are read-only, transactional, and
support XA.

%package	spider
Summary:	Spider Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	spider
The Spider storage engine supports partitioning and xa transactions, and allows
tables of different MariaDB instances to be handled as if they were on the same
instance.

%package	extra
Summary:	MariaDB extra storage engines
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	extra
This package provides various storage engines/handlers such as:

 - handlersocket
 - query_cache_info

%package	obsolete
Summary:	MariaDB obsolete storage engines
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}


%description	obsolete
MariaDB obsolete storage engines. Federated are being replaced by XtraDB and
FederatedX storage engines. These obsolete storage engines are provided in
case you need the vanilla mysql storage engines.

%package	core
Summary:	Server core binary
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

Obsoletes:	mysql-core
Provides:	mysql-core = %{version}-%{release}

Obsoletes:  MySQL-core
Provides: MySQL-core = %{version}-%{release}

%description	core
Core mysqld server binary. For a full MariaDB database server, install
package 'mariadb'.

%package	common-core
Summary:	Common files required by core binary
Group:		System/Servers
Requires:	%{name}-common >= %{version}-%{release}
Obsoletes:	mysql-common-core
Provides:	mysql-common-core = %{version}-%{release}

Obsoletes: MySQL-common-core 
Provides: MySQL-common-core = %{version}-%{release}

%description	common-core
Common files minimally required by mysqld server binary.

%package	common
Summary:	Common files
Group:		System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(post): %{name}-client >= %{version}-%{release}
Requires(preun): %{name}-client >= %{version}-%{release}
Requires:	%{name}-client >= %{version}-%{release}

Obsoletes:	mysql-common
Provides:	mysql-common = %{version}-%{release}

Obsoletes: MySQL-common
Provides: MySQL-common = %{version}-%{release}

%description	common
Common files for the MariaDB database server.

%package	client
Summary:	Client
Group:		Databases
Requires(post): %{libname} >= %{version}-%{release}
Requires(preun): %{libname} >= %{version}-%{release}
Requires:	%{libname} >= %{version}-%{release}
Requires:	%{name}-common >= %{version}-%{release}

Obsoletes:	mysql-client
Provides:	mysql-client = %{version}-%{release}

Obsoletes:	MySQL-client
Provides:	MySQL-client = %{version}-%{release}

%description	client
This package contains the standard MariaDB clients.

%package	bench
Summary:	Benchmarks and test system
Group:		System/Servers
Requires(post): %{name}-client >= %{version}-%{release}
Requires(preun): %{name}-client >= %{version}-%{release}
Requires:	%{name}-client >= %{version}-%{release}
Recommends:	%{name} >= %{version}-%{release}

Obsoletes:	mysql-bench 
Provides:	mysql-bench = %{version}-%{release}

Obsoletes:	MySQL-bench 
Provides:	MySQL-bench = %{version}-%{release}

%description	bench
This package contains MariaDB benchmark scripts and data.

%package -n	%{libname}
Summary:	Shared libraries
Group:		System/Libraries
Provides:	%{name}-shared-libs = %{version}-%{release}
Provides:	%{name}-shared = %{version}-%{release}

Provides:	%{mysql_libname} = %{version}-%{release}


%description -n	%{libname}
This package contains the shared libraries (*.so*) which certain languages and
applications need to dynamically load and use MariaDB.

%package -n	%{develname}
Summary:	Development header files and libraries
Group:		Development/Other
Requires(post): %{libname} >= %{version}-%{release}
Requires(preun): %{libname} >= %{version}-%{release}
Requires(post): %{name}-common >= %{version}-%{release}
Requires(preun): %{name}-common >= %{version}-%{release}
Requires(post): %{name}-client >= %{version}-%{release}
Requires(preun): %{name}-client >= %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name}-common >= %{version}-%{release}
Requires:	%{name}-client >= %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	%{libname}-devel = %{version}-%{release}
Obsoletes:	%{libname}-devel < %{version}-%{release}
Obsoletes:	%{old_staticdevelname} < %{version}-%{release}

Obsoletes:	%{mysql_develname}
Provides:	%{mysql_develname} = %{version}-%{release}

Provides:	mysql-devel = %{version}-%{release}

%description -n	%{develname}
This package contains the development header files and libraries necessary to
develop MariaDB client applications.

%package -n 	%{libmariadbembedded}
Summary: 	MariaDB as an embeddable library
Group: 		System/Libraries
Provides: 	%{name}-embedded = %{version}-%{release}
Obsoletes: 	%{name}-embedded < %{version}-%{release}
Provides:	%{libmysqlembedded} = %{version}-%{release}
Obsoletes:	%{libmysqlembedded} < %{version}-%{release}

%description -n %{libmariadbembedded}
MariaDB is a multi-user, multi-threaded SQL database server. This
package contains a version of the MariaDB server that can be embedded
into a client application instead of running as a separate process.

The API is identical for the embedded MariaDB version and the client/server
version.

%package -n 	%{libmariadbembedded_devel}
Summary: 	Development files for MySQL as an embeddable library
Group: 		Development/Other
Provides: 	%{name}-embedded-devel = %{version}-%{release}
Obsoletes: 	%{name}-embedded-devel < %{version}-%{release}
Requires: 	%{libmariadbembedded} = %{version}-%{release}
Requires: 	%{develname} = %{version}-%{release}
Provides:	%{libmysqlembedded_devel} = %{version}-%{release}
Obsoletes:	%{libmysqlembedded_devel} < %{version}-%{release}
Provides:	mysql-embedded-devel = %{version}-%{release}
Conflicts:	mariadb-bench < %{version}-%{release}

%description -n %{libmariadbembedded_devel}
MariaDB is a multi-user, multi-threaded SQL database server. This
package contains files needed for developing and testing with
the embedded version of the MariaDB server.
 
The API is identical for the embedded MariaDB version and the client/server
version.


%prep
%setup -q
%apply_patches

# no bundled pcre
rm -rf pcre

mkdir -p uplos
cp %{SOURCE3} uplos/my.cnf

# remove the sql_yacc.cc file so that bison will regenerate it properly, even if it's patched
rm -f sql/sql_yacc.cc


# antiborker
perl -pi -e "s|\@bindir\@|%{_bindir}|g" support-files/* scripts/*
perl -pi -e "s|\@sbindir\@|%{_sbindir}|g" support-files/* scripts/*
perl -pi -e "s|\@libexecdir\@|%{_sbindir}|g" support-files/* scripts/*
perl -pi -e "s|\@localstatedir\@|/var/lib/mysql|g" support-files/* scripts/*
perl -pi -e "s|^basedir=.*|basedir=%{_prefix}|g" support-files/* scripts/mysql_install_db*

# workaround for upstream bug #56342
rm -f mysql-test/t/ssl_8k_key-master.opt
rm -f mysql-test/t/file_contents.test

# fix distribution name
sed -i 's/Source distribution/UPLOS MariaDB Server/' mysql-test/suite/percona/innodb_sys_index.result

%build

## MariaDB
%serverbuild
export CFLAGS="${CFLAGS:-%{optflags}} -fno-delete-null-pointer-checks"
export CXXFLAGS="${CXXFLAGS:-%{optflags}} -fno-delete-null-pointer-checks"
export FFLAGS="${FFLAGS:-%{optflags}}"
export LC_ALL=C

%cmake \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DINSTALL_SBINDIR=sbin \
    -DMYSQL_DATADIR=/var/lib/mysql \
    -DSYSCONFDIR=%{_sysconfdir} \
    -DINSTALL_PLUGINDIR=%{_lib}/mysql/plugin \
    -DINSTALL_MANDIR=share/man \
    -DINSTALL_SHAREDIR=share/mysql \
    -DINSTALL_LIBDIR=%{_lib} \
    -DINSTALL_INCLUDEDIR=include/mysql \
    -DINSTALL_INFODIR=share/info \
    -DINSTALL_MYSQLDATADIR=/var/lib/mysql \
    -DINSTALL_MYSQLTESTDIR=share/mysql/mysql-test \
    -DINSTALL_SQLBENCHDIR=share/mysql \
    -DINSTALL_SUPPORTFILESDIR=share/mysql \
    -DINSTALL_MYSQLSHAREDIR=share/mysql \
    -DMYSQL_UNIX_ADDR=/var/lib/mysql/mysql.sock \
    -DWITH_READLINE=0 \
    -DWITH_LIBEDIT=0 \
    -DWITH_LIBWRAP=1 \
    -DWITH_SSL=system \
    -DWITH_ZLIB=system \
    -DWITH_PRCE=system \
    -DWITH_PIC=1 \
    -DMYSQL_TCP_PORT=3306 \
    -DEXTRA_CHARSETS=all \
    -DENABLED_LOCAL_INFILE=1 \
    -DENABLE_DTRACE=0 \
    -DWITH_EMBEDDED_SERVER=1 \
    -DMYSQL_USER=%{muser} \
%if %{build_debug}
    -DWITH_DEBUG=1 \
%else
    -DWITH_DEBUG=0 \
%endif
    -DFEATURE_SET="community" \
    -DRPM=1 \
    -DCOMPILATION_COMMENT="UPLOS MariaDB Server" \
    -DPLUGIN_ARIA=STATIC \
    -DPLUGIN_PARTITION=STATIC \
    -DPLUGIN_PERFSCHEMA=STATIC \
    -DPLUGIN_XTRADB=STATIC \
    -DPLUGIN_ARCHIVE=DYNAMIC \
    -DPLUGIN_AUDIT_NULL=DYNAMIC \
    -DPLUGIN_AUTH_0X0100=DYNAMIC \
    -DPLUGIN_AUTH_PAM=DYNAMIC \
    -DPLUGIN_AUTH_SOCKET=DYNAMIC \
    -DPLUGIN_AUTH_TEST_PLUGIN=DYNAMIC \
    -DPLUGIN_BLACKHOLE=DYNAMIC \
%if %with java
    -DPLUGIN_CASSANDRA=DYNAMIC \
%else
    -DPLUGIN_CASSANDRA=NO \
%endif
    -DPLUGIN_CONNECT=DYNAMIC \
    -DPLUGIN_DEBUG_KEY_MANAGEMENT=DYNAMIC \
    -DPLUGIN_DIALOG=DYNAMIC \
    -DPLUGIN_DIALOG_EXAMPLES=DYNAMIC \
    -DPLUGIN_FEDERATED=DYNAMIC \
    -DPLUGIN_FEDERATEDX=DYNAMIC \
    -DPLUGIN_FEEDBACK=DYNAMIC \
    -DPLUGIN_FILE_KEY_MANAGEMENT=DYNAMIC \
    -DPLUGIN_FTEXAMPLE=DYNAMIC \
    -DPLUGIN_HANDLERSOCKET=DYNAMIC \
    -DPLUGIN_INNOBASE=DYNAMIC \
    -DPLUGIN_LOCALES=DYNAMIC \
    -DPLUGIN_METADATA_LOCK_INFO=DYNAMIC \
    -DPLUGIN_MROONGA=DYNAMIC \
    -DPLUGIN_MYSQL_CLEAR_PASSWORD=DYNAMIC \
%if %{build_oqgraph}
    -DPLUGIN_OQGRAPH=DYNAMIC \
%else
    -DPLUGIN_OQGRAPH=NO \
%endif
    -DPLUGIN_QA_AUTH_CLIENT=DYNAMIC \
    -DPLUGIN_QA_AUTH_INTERFACE=DYNAMIC \
    -DPLUGIN_QA_AUTH_SERVER=DYNAMIC \
    -DPLUGIN_QUERY_CACHE_INFO=DYNAMIC \
    -DPLUGIN_QUERY_RESPONSE_TIME=DYNAMIC \
    -DPLUGIN_SEMISYNC_MASTER=DYNAMIC \
    -DPLUGIN_SEMISYNC_SLAVE=DYNAMIC \
    -DPLUGIN_SEQUENCE=DYNAMIC \
    -DPLUGIN_SERVER_AUDIT=DYNAMIC \
    -DPLUGIN_SIMPLE_PASSWORD_CHECK=DYNAMIC \
    -DPLUGIN_SPHINX=DYNAMIC \
    -DPLUGIN_SPIDER=DYNAMIC \
    -DPLUGIN_SQL_ERRLOG=DYNAMIC \
    -DPLUGIN_TEST_SQL_DISCOVERY=DYNAMIC \
    -DPLUGIN_WSREP_INFO=DYNAMIC \
    -DPLUGIN_DAEMON_EXAMPLE=NO \
    -DPLUGIN_EXAMPLE=NO \
    -DPLUGIN_EXAMPLE_KEY_MANAGEMENT=NO \
    -DPLUGIN_TOKUDB=NO

%make VERBOSE=1

%install
rm -rf %buildroot
# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

%if %{build_debug}
export DONT_STRIP=1
%endif

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_var}/log/mysqld
install -d %{buildroot}/var/lib/mysql/{mysql,test}

%makeinstall_std -C build

# exclude loaddata7 from being converted
export EXCLUDE_FROM_EOL_CONVERSION="std_data/loaddata7.dat"

# install configuration file
install -m0644 uplos/my.cnf %{buildroot}%{_sysconfdir}/my.cnf

install -m 0755 %{SOURCE12} %{buildroot}%{_sbindir}/mysqld-prepare-db-dir
install -m 0755 %{SOURCE13} %{buildroot}%{_sbindir}/mysqld-wait-ready

# cleanup some config files
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/cassandra.cnf \
    %{buildroot}%{_sysconfdir}/my.cnf.d/connect.cnf \
     %{buildroot}%{_sysconfdir}/my.cnf.d/oqgraph.cnf

# magic by anssi
pushd %{buildroot}%{_sysconfdir}/my.cnf.d
%{expand:%(for i in {50..72}; do echo "install -m 644 %%SOURCE$i ."; done)}
popd

%if ! %with java
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/ha_cassandra.cnf
%endif

%if ! %{build_oqgraph}
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/ha_oqgraph.cnf
%endif

# bork
mv %{buildroot}%{_datadir}/mysql/aclocal %{buildroot}%{_datadir}/aclocal

pushd %{buildroot}%{_bindir}
    ln -sf mysqlcheck mysqlrepair
    ln -sf mysqlcheck mysqlanalyze
    ln -sf mysqlcheck mysqloptimize
popd

# nuke -Wl,--as-needed from the mysql_config file
perl -pi -e "s|^ldflags=.*|ldflags=\'-rdynamic\'|g" %{buildroot}%{_bindir}/mysql_config

# cmake generates some completely wacko references to -lprobes_mysql when
# building with dtrace support.  Haven't found where to shut that off,
# so resort to this blunt instrument.  While at it, let's not reference
# libmysqlclient_r anymore either.
sed -e 's/-lprobes_mysql//' -e 's/-lmysqlclient_r/-lmysqlclient/' \
	%{buildroot}%{_bindir}/mysql_config >mysql_config.tmp
cp -f mysql_config.tmp %{buildroot}%{_bindir}/mysql_config
chmod 755 %{buildroot}%{_bindir}/mysql_config
install -m 0755 -d %{buildroot}/var/lib/mysql

# Remove libmysqld.a, + hardlink libmysqld.so.%{libmysqlembedded_major} so that it's provided
rm -f %{buildroot}%{_libdir}/libmysqld.a
ln %{buildroot}%{_libdir}/libmysqld.so.%{major} %{buildroot}%{_libdir}/libmysqld.so.%{libmysqlembedded_major}.%{libmysqlembedded_minor}
ln -s libmysqld.so.%{libmysqlembedded_major}.%{libmysqlembedded_minor} %{buildroot}%{_libdir}/libmysqld.so.%{libmysqlembedded_major}

cp -rp %{buildroot}%{_datadir}/mysql/english %{buildroot}%{_datadir}/mysql/default

# libmysqlclient_r is no more.  Upstream tries to replace it with symlinks
# but that really doesn't work (wrong soname in particular).  We'll keep
# just the devel libmysqlclient_r.so link, so that rebuilding without any
# source change is enough to get rid of dependency on libmysqlclient_r.
rm -f %{buildroot}%{_libdir}/libmysqlclient_r.so*
ln -s libmysqlclient.so %{buildroot}%{_libdir}/libmysqlclient_r.so

# remove static libs
rm -f %{buildroot}%{_libdir}/libmysqlclient.a
rm -f %{buildroot}%{_libdir}/libmysqlclient_r.a

# mysql-test includes one executable that doesn't belong under /usr/share,
# so move it and provide a symlink
mv %{buildroot}%{_datadir}/mysql/mysql-test/lib/My/SafeProcess/my_safe_process %{buildroot}%{_bindir}
ln -s %{_bindir}/my_safe_process %{buildroot}%{_datadir}/mysql/mysql-test/lib/My/SafeProcess/my_safe_process

# mysql client statically built against a local embedded library, pretty useless
rm -f %{buildroot}%{_bindir}/mysql_embedded

# this command enables plugins, but needs ini file + configuration in my.cnf
# before executing... and oh yeah, mysql must be stopped... => useless
# however, apparently tests seem to want it, even thought they don't use it.
#rm -f %{buildroot}%{_bindir}/mysql_plugin
rm -f %{buildroot}%{_libdir}/mysql/plugin/daemon_example.ini

# no RHEL4 selinux files for us
rm -rf %{buildroot}%{_datadir}/mysql/SELinux
# no solaris files for us
rm -rf %{buildroot}%{_datadir}/mysql/solaris

install -m 0755 %SOURCE1  %{buildroot}%{_sysconfdir}/init.d/mysqld
mkdir -p %buildroot/%{_var}/run/mysqld



# house cleaning
rm -rf %{buildroot}%{_datadir}/info
rm -f %{buildroot}%{_bindir}/client_test
rm -f %{buildroot}%{_bindir}/maria_add_gis_sp.sql
rm -f %{buildroot}%{_bindir}/make_win_binary_distribution
rm -f %{buildroot}%{_bindir}/make_win_src_distribution
rm -f %{buildroot}%{_datadir}/mysql/binary-configure
rm -f %{buildroot}%{_datadir}/mysql/config.huge.ini
rm -f %{buildroot}%{_datadir}/mysql/config.medium.ini
rm -f %{buildroot}%{_datadir}/mysql/config.small.ini
rm -f %{buildroot}%{_datadir}/mysql/mysqld_multi.server
rm -f %{buildroot}%{_datadir}/mysql/mysql-log-rotate
rm -f %{buildroot}%{_datadir}/mysql/mysql.server
rm -f %{buildroot}%{_datadir}/mysql/ndb-config-2-node.ini
rm -f %{buildroot}%{_datadir}/mysql/binary-configure
rm -f %{buildroot}%{_mandir}/man1/make_win_bin_dist.1*
rm -f %{buildroot}%{_mandir}/man1/make_win_src_distribution.1*
rm -f %{buildroot}%{_datadir}/mysql/magic
rm -f %{buildroot}%{_sbindir}/rcmysql
rm -rf %{buildroot}%{_datadir}/mysql/pkgconfig
rm -rf %{buildroot}%{_datadir}/mysql/policy
rm -rf %{buildroot}%{_datadir}/mysql/systemd
rm -f %{buildroot}%{_bindir}/mariadb-service-convert
rm -f %{buildroot}%{_bindir}/galera_new_cluster
rm -f %{buildroot}%{_bindir}/galera_recovery
rm -f %{buildroot}%{_datadir}/mysql/wsrep_notify

# no idea how to fix this
rm -rf %{buildroot}%{_prefix}/data
rm -rf %{buildroot}%{_prefix}/docs
rm -rf %{buildroot}%{_prefix}/scripts
rm -rf %{buildroot}%{_datadir}/doc
rm -rf %{buildroot}%{_sysconfdir}/logrotate.d/mysql

rm -f %{buildroot}%{_sysconfdir}/init.d/mysql

%multiarch_binaries %{buildroot}%{_bindir}/mysql_config
%multiarch_includes %{buildroot}%{_includedir}/mysql/my_config.h

cat > README.uplos <<EOF

NOTE: MariaDB is installed without root password, it is recommended to set the
root password with the following command as soon as possible:

   mysqladmin password

 * The generation of the initial system mysql database is now done when mysql
   is started from the initscript and only if the /var/lib/mysql/mysql
   directory is empty (mysql_install_db). Previousely this was quite hidden and
   silently done at (rpm) install time. As a consequence to this change you may
   have to perform some manual tasks to upgrade the mysql system database and
   such. So, doing something like this might help you:

   service mysqld stop
   TMPDIR=/var/tmp mysql_install_db

The cluster functionalities (ndb) has been deactivated and will be removed in
future mysql versions. Oracle has a new product named mysql-cluster that
replaces the cluster functionalities.

The mysql-common-core package ships with a default /etc/my.cnf file that is 
based on the my-medium.cnf file that comes with the source code.
EOF

################################################################################
# run the tests
%if %{build_test}
# disable failing tests
#    --ssl \
pushd build/mysql-test
export LANG=C
export LC_ALL=C
export LANGUAGE=C
    perl ./mysql-test-run.pl \
    --mtr-build-thread="$((${RANDOM} % 100))" \
    --retry=0 \
    --big-test \
    --force \
    --max-test-fail=0 \
    --testcase-timeout=60 \
    --suite-timeout=1200 || false
popd
%endif

%pre

#drop and replace /etc/init.d/mysqld
if [ -f /etc/init.d/mysqld ]; then
rm -f /etc/init.d/mysqld
fi

#backup existing database folder if present
if [ -d /var/lib/mysql ]; then
cp -rn /var/lib/mysql /opt/mysql.bak
fi

%pre common
# delete the mysql group if no mysql user is found, before adding the user
if [ -z "`getent passwd %{muser}`" ] && ! [ -z "`getent group %{muser}`" ]; then
    %{_sbindir}/groupdel %{muser} 2> /dev/null || :
fi

%_pre_useradd %{muser} /var/lib/mysql /bin/bash


%post
# Change permissions so that the user that will run the MySQL daemon
# owns all needed files.
chown -R %{muser}:%{muser} /var/lib/mysql /var/run/mysqld /var/log/mysqld

# make sure the /var/lib/mysql directory can be accessed
chmod 711 /var/lib/mysql

%_post_service mysqld

%preun
%_preun_service mysqld

%postun
%_post_service mysqld

%pre common-core
#drop and replace /etc/my.cnf
if [ -f /etc/my.cnf ]; then
rm -f /etc/my.cnf
fi

%posttrans
if [ -f /etc/init.d/mysqld ]; then
service mysqld restart
chkconfig mysqld on > /dev/null 2>&1
fi

%files
%doc README.uplos
# authentication plugins
%config(noreplace) %{_sysconfdir}/my.cnf.d/auth_gssapi.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/auth_pam.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/auth_socket.cnf
# replication plugins
%config(noreplace) %{_sysconfdir}/my.cnf.d/semisync_master.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/semisync_slave.cnf
# storage engines
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_archive.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_blackhole.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_federatedx.cnf
# sql logging plugin
%config(noreplace) %{_sysconfdir}/my.cnf.d/sql_errlog.cnf
# new since 10.x
%config(noreplace) %{_sysconfdir}/my.cnf.d/cracklib_password_check.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/locales.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/metadata_lock_info.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/query_response_time.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/server_audit.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/enable_encryption.preset
%config(noreplace) %{_sysconfdir}/init.d/mysqld

%{_sbindir}/mysqld-prepare-db-dir
%{_sbindir}/mysqld-wait-ready
# authentication plugins
%{_libdir}/mysql/plugin/auth_gssapi.so
%{_libdir}/mysql/plugin/auth_gssapi_client.so
%{_libdir}/mysql/plugin/auth_pam.so
%{_libdir}/mysql/plugin/auth_socket.so
# replication plugins
%{_libdir}/mysql/plugin/semisync_master.so
%{_libdir}/mysql/plugin/semisync_slave.so
# storage engines
%{_libdir}/mysql/plugin/ha_archive.so
%{_libdir}/mysql/plugin/ha_blackhole.so
%{_libdir}/mysql/plugin/ha_federatedx.so
# sql logging plugin
%{_libdir}/mysql/plugin/sql_errlog.so
# new since 10.x
%{_libdir}/mysql/plugin/locales.so
%{_libdir}/mysql/plugin/metadata_lock_info.so
%{_libdir}/mysql/plugin/query_response_time.so
%{_libdir}/mysql/plugin/server_audit.so
# new since 10.1.x
%{_libdir}/mysql/plugin/cracklib_password_check.so
%{_libdir}/mysql/plugin/debug_key_management.so
%{_libdir}/mysql/plugin/file_key_management.so
%{_libdir}/mysql/plugin/simple_password_check.so
%{_libdir}/mysql/plugin/wsrep_info.so

%files -n mysql-MariaDB

%files obsolete
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_innodb.cnf
%{_libdir}/mysql/plugin/ha_innodb.so
%{_libdir}/mysql/plugin/ha_federated.so

%if %with java
%files cassandra
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_cassandra.cnf
/mysql/plugin/ha_cassandra.so
%endif

%files feedback
%config(noreplace) %{_sysconfdir}/my.cnf.d/feedback.cnf
%{_libdir}/mysql/plugin/feedback.so

%if %{build_oqgraph}
%files oqgraph
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_oqgraph.cnf
%{_libdir}/mysql/plugin/ha_oqgraph.so
%endif

%files connect
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_connect.cnf
%{_libdir}/mysql/plugin/ha_connect.so

%files sphinx
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_sphinx.cnf
%{_libdir}/mysql/plugin/ha_sphinx.so

%files mroonga
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_mroonga.cnf
%{_libdir}/mysql/plugin/ha_mroonga.so
%{_datadir}/mysql/mroonga/install.sql
%{_datadir}/mysql/mroonga/uninstall.sql

%files sequence
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_sequence.cnf
%{_libdir}/mysql/plugin/ha_sequence.so

%files spider
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_spider.cnf
%{_libdir}/mysql/plugin/ha_spider.so
%{_datadir}/mysql/install_spider.sql

%files extra
%config(noreplace) %{_sysconfdir}/my.cnf.d/handlersocket.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/query_cache_info.cnf
%{_libdir}/mysql/plugin/handlersocket.so
# new optional functionality
%{_libdir}/mysql/plugin/query_cache_info.so

%files client
%config(noreplace) %{_sysconfdir}/my.cnf.d/client.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/mysql-clients.cnf
%{_bindir}/msql2mysql
%{_bindir}/mysql
%{_bindir}/mysqlaccess
%{_bindir}/mysqladmin
%{_bindir}/mysqlanalyze
%{_bindir}/mysqlbinlog
%{_bindir}/mysqlcheck
%{_bindir}/mysqldump
%{_bindir}/mysqldumpslow
%{_bindir}/mysql_find_rows
%{_bindir}/mysqlimport
%{_bindir}/mysqloptimize
%{_bindir}/mysqlrepair
%{_bindir}/mysqlshow
%{_bindir}/mysqlslap
%{_bindir}/mysql_waitpid
%{_mandir}/man1/msql2mysql.1*
%{_mandir}/man1/myisam_ftdump.1*
%{_mandir}/man1/mysql.1*
%{_mandir}/man1/mysqlaccess.1*
%{_mandir}/man1/mysqladmin.1*
%{_mandir}/man1/mysqlbinlog.1*
%{_mandir}/man1/mysqlcheck.1*
%{_mandir}/man1/mysqldump.1*
%{_mandir}/man1/mysqldumpslow.1*
%{_mandir}/man1/mysql_find_rows.1*
%{_mandir}/man1/mysqlimport.1*
%{_mandir}/man1/mysqlshow.1*
%{_mandir}/man1/mysql_waitpid.1*
# libmysqlclient plugins
%{_libdir}/mysql/plugin/dialog.so
%{_libdir}/mysql/plugin/mysql_clear_password.so
%{_libdir}/mysql/plugin/JdbcInterface.jar

%files bench
%doc build/sql-bench/README
%{_bindir}/my_safe_process
%{_bindir}/mysql_client_test
%{_datadir}/mysql/sql-bench
%attr(-,mysql,mysql) %{_datadir}/mysql/mysql-test
%{_mandir}/man1/mysql-stress-test.pl.1*
%{_mandir}/man1/mysql-test-run.pl.1*
%{_mandir}/man1/mysql_client_test.1*
%{_mandir}/man1/mysqltest.1*
%{_libdir}/mysql/plugin/adt_null.so
%{_libdir}/mysql/plugin/auth_0x0100.so
%{_libdir}/mysql/plugin/auth_test_plugin.so
%{_libdir}/mysql/plugin/dialog_examples.so
%{_libdir}/mysql/plugin/ha_test_sql_discovery.so
%{_libdir}/mysql/plugin/mypluglib.so
%{_libdir}/mysql/plugin/qa_auth_client.so
%{_libdir}/mysql/plugin/qa_auth_interface.so
%{_libdir}/mysql/plugin/qa_auth_server.so

%files core
%{_sbindir}/mysqld

%files common-core
%config(noreplace) %{_sysconfdir}/my.cnf.d/server.cnf
%{_sysconfdir}/my.cnf
%dir %{_datadir}/mysql
%{_datadir}/mysql/english
%{_datadir}/mysql/charsets

%files common
%doc README COPYING
%dir %{_sysconfdir}/my.cnf.d
%dir %{_libdir}/mysql/plugin
%{_bindir}/aria_chk
%{_bindir}/aria_dump_log
%{_bindir}/aria_ftdump
%{_bindir}/aria_pack
%{_bindir}/aria_read_log
%{_bindir}/innochecksum
%{_bindir}/myisamchk
%{_bindir}/myisam_ftdump
%{_bindir}/myisamlog
%{_bindir}/myisampack
%{_bindir}/my_print_defaults
%{_bindir}/mysqlbug
%{_bindir}/mysql_convert_table_format
%{_bindir}/mysqld_multi
%{_bindir}/mysqld_safe
%{_bindir}/mysql_fix_extensions 
%{_bindir}/mysqlhotcopy
%{_bindir}/mysql_install_db
%{_bindir}/mysql_plugin
%{_bindir}/mysql_secure_installation
%{_bindir}/mysql_setpermission
%{_bindir}/mysqltest
%{_bindir}/mysql_tzinfo_to_sql
%{_bindir}/mysql_upgrade
%{_bindir}/mysql_zap
%{_bindir}/mytop
%{_bindir}/perror
%{_bindir}/replace
%{_bindir}/resolveip
%{_bindir}/resolve_stack_dump
%{_bindir}/wsrep_sst_common
%{_bindir}/wsrep_sst_mysqldump
%{_bindir}/wsrep_sst_rsync
%{_bindir}/wsrep_sst_xtrabackup
%{_bindir}/wsrep_sst_xtrabackup-v2
%attr(0755,%{muser},%{muser}) %dir /var/lib/mysql
%attr(0755,%{muser},%{muser}) %dir /var/lib/mysql/mysql
%attr(0755,%{muser},%{muser}) %dir /var/lib/mysql/test
%attr(0755,%{muser},%{muser}) %dir %{_var}/log/mysqld
%attr(0755,%{muser},%{muser}) %dir %{_var}/run/mysqld
%{_datadir}/mysql/*.cnf
%{_datadir}/mysql/fill_help_tables.sql
%{_datadir}/mysql/mysql_performance_tables.sql
%{_datadir}/mysql/mysql_system_tables.sql
%{_datadir}/mysql/mysql_system_tables_data.sql
%{_datadir}/mysql/mysql_test_data_timezone.sql
%{_datadir}/mysql/mysql_to_mariadb.sql
%{_datadir}/mysql/errmsg-utf8.txt
%{_datadir}/mysql/maria_add_gis_sp_bootstrap.sql
%{_datadir}/mysql/maria_add_gis_sp.sql
%{_datadir}/mysql/czech
%{_datadir}/mysql/danish
%{_datadir}/mysql/dutch
%{_datadir}/mysql/estonian
%{_datadir}/mysql/french
%{_datadir}/mysql/german
%{_datadir}/mysql/greek
%{_datadir}/mysql/hungarian
%{_datadir}/mysql/italian
%{_datadir}/mysql/japanese
%{_datadir}/mysql/korean
%{_datadir}/mysql/norwegian
%{_datadir}/mysql/norwegian-ny
%{_datadir}/mysql/polish
%{_datadir}/mysql/portuguese
%{_datadir}/mysql/romanian
%{_datadir}/mysql/russian
%{_datadir}/mysql/serbian
%{_datadir}/mysql/slovak
%{_datadir}/mysql/spanish
%{_datadir}/mysql/swedish
%{_datadir}/mysql/ukrainian
%{_mandir}

%files -n %{libname}
%{_libdir}/libmysqlclient.so.%{major}*

%files -n %{develname}
%doc INSTALL-SOURCE
%multiarch %{multiarch_bindir}/mysql_config
%{_bindir}/mysql_config
%{_libdir}/libmysqlclient_r.so
%{_libdir}/libmysqlclient.so
%dir %{_includedir}/mysql
%dir %{_includedir}/mysql/psi
%{_includedir}/mysql/*.h
%{_includedir}/mysql/private/*.h
%{_includedir}/mysql/private/atomic/*.h
%{_includedir}/mysql/psi/*.h
%multiarch %{multiarch_includedir}/mysql/my_config.h
%{_mandir}/man1/mysql_config.1*
%{_datadir}/aclocal/mysql.m4
# mysqlservices library is static, because it doesn't contain any code
# itself, and is meant to be statically linked to all plugins.
%{_libdir}/libmysqlservices.a

%files -n %{libmariadbembedded}
%doc README COPYING 
%{_datadir}/mysql/default
%{_libdir}/libmysqld.so.%{major}
%{_libdir}/libmysqld.so.%{libmysqlembedded_major}*

%files -n %{libmariadbembedded_devel}
%{_libdir}/libmysqld.so
%{_bindir}/mysql_client_test_embedded
%{_bindir}/mysqltest_embedded
%{_mandir}/man1/mysql_client_test_embedded.1*
%{_mandir}/man1/mysqltest_embedded.1*


%changelog
* Tue Jan 24 2017 adrianomorselli <adrianomorselli> 10.1.20-1uplos2017
- rebuild

* Fri Dec 16 2016 bb <bb> 10.1.20-1pclos2017
- update

* Sun Dec 11 2016 bb <bb> 10.1.19-2pclos2017
- try to fix updating for KDE4

* Mon Dec 05 2016 bb <bb> 10.1.19-1pclos2017
- import from france with mods for pclos

